///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V6.10.1.52143/W32 for ARM    20/Sep/2011  17:38:36 /
// Copyright 1999-2010 IAR Systems AB.                                        /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  D:\Workspace\test only\kinetis-sc\src\projects\FTM_PWM\ /
//                    FTM_PWM.c                                               /
//    Command line =  "D:\Workspace\test only\kinetis-sc\src\projects\FTM_PWM /
//                    \FTM_PWM.c" -D IAR -D TWR_K40X256 -lCN                  /
//                    "D:\Workspace\test only\kinetis-sc\build\iar\FTM_PWM\FL /
//                    ASH_256KB_PFLASH\List\" -lB "D:\Workspace\test          /
//                    only\kinetis-sc\build\iar\FTM_PWM\FLASH_256KB_PFLASH\Li /
//                    st\" -o "D:\Workspace\test                              /
//                    only\kinetis-sc\build\iar\FTM_PWM\FLASH_256KB_PFLASH\Ob /
//                    j\" --no_cse --no_unroll --no_inline --no_code_motion   /
//                    --no_tbaa --no_clustering --no_scheduling --debug       /
//                    --endian=little --cpu=Cortex-M4 -e --fpu=None           /
//                    --dlib_config "C:\Program Files\IAR Systems\Embedded    /
//                    Workbench 6.0\arm\INC\c\DLib_Config_Normal.h" -I        /
//                    "D:\Workspace\test only\kinetis-sc\build\iar\FTM_PWM\.. /
//                    \..\..\src\projects\FTM_PWM\" -I "D:\Workspace\test     /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\common\" /
//                     -I "D:\Workspace\test only\kinetis-sc\build\iar\FTM_PW /
//                    M\..\..\..\src\cpu\" -I "D:\Workspace\test              /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\cpu\head /
//                    ers\" -I "D:\Workspace\test                             /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\drivers\ /
//                    uart\" -I "D:\Workspace\test                            /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\drivers\ /
//                    mcg\" -I "D:\Workspace\test                             /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\drivers\ /
//                    wdog\" -I "D:\Workspace\test                            /
//                    only\kinetis-sc\build\iar\FTM_PWM\..\..\..\src\platform /
//                    s\" -I "D:\Workspace\test only\kinetis-sc\build\iar\FTM /
//                    _PWM\..\" -Ol --use_c++_inline                          /
//    List file    =  D:\Workspace\test only\kinetis-sc\build\iar\FTM_PWM\FLA /
//                    SH_256KB_PFLASH\List\FTM_PWM.s                          /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME FTM_PWM

        EXTERN in_char
        EXTERN out_char

        PUBLIC main
        PUBLIC vfnFTMEdgeAligned

// D:\Workspace\test only\kinetis-sc\src\projects\FTM_PWM\FTM_PWM.c
//    1 /*
//    2  * File:		FTM_PWM.c
//    3  * Purpose:		Main process
//    4  *
//    5  */
//    6 
//    7 #include "common.h"
//    8 
//    9 #define FTM_12MHZ_PERIOD	(0x00000004UL)
//   10 #define FTM_12MHZ_DUTY		(0x00000002UL)
//   11 
//   12 #define FTM_25MHZ_PERIOD	(0x00000002UL)
//   13 #define FTM_25MHZ_DUTY		(0x00000001UL)
//   14 
//   15 void vfnFTMEdgeAligned (uint32 u32Period, uint32 u32Duty);
//   16 
//   17 /********************************************************************/

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   18 void main (void)
//   19 {
main:
        PUSH     {R7,LR}
//   20 	char ch;
//   21         
//   22         vfnFTMEdgeAligned(FTM_12MHZ_PERIOD,FTM_12MHZ_DUTY);
        MOVS     R1,#+2
        MOVS     R0,#+4
        BL       vfnFTMEdgeAligned
//   23       
//   24 
//   25 
//   26 	while(1)
//   27 	{
//   28 		ch = in_char();
??main_0:
        BL       in_char
//   29 		out_char(ch);
        UXTB     R0,R0            ;; ZeroExt  R0,R0,#+24,#+24
        BL       out_char
        B.N      ??main_0
//   30 	} 
//   31 }
//   32 
//   33 /*!
//   34       \fn void vfnFTMEdgeAligned (uint32 u32Period, uint32 u32Duty)
//   35       \brief  Initializes FTM0 for PWM Edge aligned
//   36 	  \param  uint32 u32Period: Period for the output
//   37 	  \param  uint32 u32Duty: PWM duty cycle
//   38       \return void
//   39 */ 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   40 void vfnFTMEdgeAligned (uint32 u32Period, uint32 u32Duty)
//   41 {
//   42 	SIM_SCGC6 |= SIM_SCGC6_FTM0_MASK; /* Enable clock for FTM0 */
vfnFTMEdgeAligned:
        LDR.N    R2,??DataTable0  ;; 0x4004803c
        LDR      R2,[R2, #+0]
        ORRS     R2,R2,#0x1000000
        LDR.N    R3,??DataTable0  ;; 0x4004803c
        STR      R2,[R3, #+0]
//   43 
//   44 	PORTC_PCR1 = 0x400; /* FTM0_CH0 enable on PTC1 */
        LDR.N    R2,??DataTable0_1  ;; 0x4004b004
        MOV      R3,#+1024
        STR      R3,[R2, #+0]
//   45 		
//   46 	FTM0_MOD = u32Period; /* PWM period */
        LDR.N    R2,??DataTable0_2  ;; 0x40038008
        STR      R0,[R2, #+0]
//   47 	
//   48 	/* Configure timers for edge aligned PWM High True Pulses */
//   49 	
//   50 	FTM0_C0SC = 0x28; /* No Interrupts; High True pulses on Edge Aligned PWM */
        LDR.N    R0,??DataTable0_3  ;; 0x4003800c
        MOVS     R2,#+40
        STR      R2,[R0, #+0]
//   51 	
//   52 	FTM0_C0V = u32Duty; /* 50% pulse width */  
        LDR.N    R0,??DataTable0_4  ;; 0x40038010
        STR      R1,[R0, #+0]
//   53 	
//   54 	FTM0_SC = 0x08; /* Edge Aligned PWM running from BUSCLK / 1 */
        LDR.N    R0,??DataTable0_5  ;; 0x40038000
        MOVS     R1,#+8
        STR      R1,[R0, #+0]
//   55 }
        BX       LR               ;; return

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0:
        DC32     0x4004803c

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0_1:
        DC32     0x4004b004

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0_2:
        DC32     0x40038008

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0_3:
        DC32     0x4003800c

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0_4:
        DC32     0x40038010

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable0_5:
        DC32     0x40038000

        SECTION __DLIB_PERTHREAD:DATA:REORDER:NOROOT(0)

        SECTION __DLIB_PERTHREAD_init:DATA:REORDER:NOROOT(0)

        END
// 
// 88 bytes in section .text
// 
// 88 bytes of CODE memory
//
//Errors: none
//Warnings: none
